% Automatos Exemplos

% Examples

:- object(afd1,
	instantiates(classFa)).

	estadoInicial(0).
	
	estadoFinal(2).

	delta(0, a, 1).
	delta(1, a, 2).
	delta(2, a, 0).

:- end_object.

:- object(afd2,
	instantiates(classFa) ).

	estadoInicial(0).
	
	estadoFinal(1).
	
	delta(0 , a, 1 ).
	delta(0 , b, 0 ).
	delta(1 , a, 2 ).
	delta(1 , b, 0 ).
	delta(2 , b, 2 ).
	delta(2 , a, 2 ).
 
	% should give not a dfa 
	% if the following transition is included
  % delta(2 , b, 1 ).
  % then this object will not represent a dfa
  % Good for checking the isaDfa predicate.

:- end_object.

:- object(ndfa1,
	instantiates(classFa) ).

	estadoInicial(0).
	estadoFinal(3).
	estadoFinal(5).

	delta(0 , 0, 1 ).
	delta(0 , 0, 4 ).
	delta(1 , 0, 2 ).
	delta(2 , 0, 3 ).
	delta(4 , 0, 5 ).
	delta(5 , 0, 4 ).

:- end_object.

:- object(ndfa2,
	instantiates(classFa) ).

	estadoInicial(1).
	estadoFinal(4).

	digitos([0,1,2,3,4,5,6,7,8,9]).

	delta(1 , D, 2 ):-digitos(L),list::member(D,L).
	delta(2 , ., 3 ).
	delta(3 , D, 4 ):-digitos(L),list::member(D,L).

	epsilon(2,1).
	epsilon(2,4).
	epsilon(4,3).

:- end_object.
% afd3::aceita([a,b,a,b,b], Trace).


:- object(afd3,
	instantiates(classFa)).

	estadoInicial(q0).
	
	estadoFinal(final).

	delta(q0, a, q1).
	delta(q0, b, q0).
	delta(q1, a, q0).
	delta(q1, b, final).
	delta(final,a,final).
	delta(final,b,q1).

:- end_object.

:- object(xyz,
	instantiates(classFa)).

	estadoInicial(0).
	estadoInicial(ini2).
	
	estadoFinal(2).
	estadoFinal(1).

	delta(0, a, 1).
	delta(ini2, ini2, 1).
	delta(1, a, 2).
	delta(2, ab, 0).
	
	epsilon(2,1).
	epsilon(2,1).

:- end_object.
